apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  name: {{ bc_basename | lower }}-{{ bc_tag | default(bc_ref | default('master')) | lower }}
  namespace: {{ namespace }}
spec:
  failedBuildsHistoryLimit: {{ bc_keep_failed | default(1) }}
  output:
    to:
{% if (bc_tokind | default('ImageStreamTag')) == 'ImageStreamTag' and (do_registry | default(False)) == False %}
      kind: DockerImage
      name: {{ docker_registry }}/{{ namespace }}/{{ bc_toimage | default(bc_basename) }}:{{ bc_tag | default(bc_ref | default('master')) }}
{% else %}
      kind: {{ bc_tokind | default('ImageStreamTag') }}
      name: {{ bc_toimage | default(bc_basename) }}:{{ bc_tag | default(bc_ref | default('master')) }}
{% endif %}
  resources:
    limits:
      cpu: "{{ bc_cpu_limit | default('100m') }}"
      memory: "{{ bc_memory_limit | default('256Mi') }}"
    requests:
      cpu: "{{ bc_cpu_request | default('100m') }}"
      memory: "{{ bc_memory_request | default('256Mi') }}"
  runPolicy: {{ bc_run_policy | default('Serial') }}
  source:
    contextDir: {{ bc_context | default('/') }}
    git:
      uri: {{ bc_source }}
      ref: "{{ bc_ref | default('master') }}"
{% if bc_secret | default(False) %}
    sourceSecret:
      name: {{ bc_secret }}
{% endif %}
    type: Git
  strategy:
{% if (bc_type | default('Docker')) == 'Source' %}
    sourceStrategy:
{% else %}
    dockerStrategy:
{% if bc_dockerfile | default(False) %}
      dockerfilePath: {{ bc_dockerfile }}
{% else %}
      dockerfilePath: Dockerfile
{% endif %}
{% if bc_inbuild_clonepw | default(False) or bc_inbuild_cloneuser | default(False) %}
      buildArgs:
{% if bc_inbuild_clonepw | default(False) %}
      - name: SRC_CLONE_PASS
        value: "{{ bc_inbuild_clonepw }}"
{% endif %}
{% if bc_inbuild_cloneuser | default(False) %}
      - name: SRC_CLONE_USER
        value: "{{ bc_inbuild_cloneuser }}"
{% endif %}
{% endif %}
{% endif %}
{% if (proxy_host | default(False)) or squid_address is defined or (bc_env | default([])) | length > 0 %}
      env:
{% for envvar in bc_env if envvar['name'] is defined %}
      - name: "{{ envvar['name'] }}"
        value: "{{ envvar['value'] | default('') }}"
{% endfor %}
{% if proxy_host | default(False) %}
      - name: http_proxy
        value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
      - name: https_proxy
        value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
      - name: no_proxy
        value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
      - name: HTTP_PROXY
        value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
      - name: HTTPS_PROXY
        value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
      - name: NO_PROXY
        value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
      - name: http_proxy
        value: {{ squid_address }}
      - name: https_proxy
        value: {{ squid_address }}
      - name: no_proxy
        value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
      - name: HTTP_PROXY
        value: {{ squid_address }}
      - name: HTTPS_PROXY
        value: {{ squid_address }}
      - name: NO_PROXY
        value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
      - name: http_proxy
        value: ""
      - name: https_proxy
        value: ""
      - name: no_proxy
        value: ""
      - name: HTTP_PROXY
        value: ""
      - name: HTTPS_PROXY
        value: ""
      - name: NO_PROXY
        value: ""
{% endif %}
{% endif %}
      forcePull: {{ 'true' if (bc_forcepull | default(True)) else 'false' }}
{% if bc_fromimage | default(False) %}
      from:
{% if (bc_fromkind | default('DockerImage')) == 'ImageStreamTag' and (do_registry | default(False)) == False %}
        kind: DockerImage
        name: {{ docker_registry }}/{{ namespace }}/{{ bc_fromimage }}
{% else %}
        kind: {{ bc_fromkind | default('DockerImage') }}
        name: {{ bc_fromimage }}
{% endif %}
{% endif %}
      noCache: {{ 'true' if (bc_nocache | default(False)) else 'false' }}
    type: {{ bc_type | default('Docker') }}
  successfulBuildsHistoryLimit: {{ bc_keep_success | default(1) }}
{% if do_build_triggers | default(True) %}
  triggers:
{% if bc_webhook_secret | default(False) %}
  - generic:
      secret: "{{ bc_webhook_secret }}"
    type: Generic
{% elif bc_fromimage | default(False) %}
  - type: ImageChange
{% else %}
  - type: ConfigChange
{% endif %}
{% endif %}
